% This code computes symmetric part detections in an image as described in:
% T. Lee, S. Fidler, S. Dickinson.
% Detecting Curved Symmetric Parts using a Deformable Disc Model.
% IEEE International Conference on Computer Vision, 2013.

% Set paths
restoredefaultpath;
addpath('./display');
addpath('./features');
addpath('./evaluation');
addpath(genpath('./external'));

% Set parameters
clear global params;
global params;

params.graph.id = 'Ternary';
params.graph.vis = 0;
params.graph.recompute = 0;

params.grouping.id = 'seq';
params.grouping.vis = 0; % set this to make PDF showing overlaid detections
params.grouping.recompute = 0;

params.feature.id = 'DefDisc';
params.feature.minScore = 0.1;

params.feature.string = sprintf('%s', ...
   params.feature.id);
params.graph.string = sprintf('Graph__%s_%s', ...
   params.graph.id, params.feature.string);
params.grouping.string = sprintf('TopParts__%s_%s', ...
   params.graph.id, params.feature.string);

load('IdDataset','IdIm');  % points to images in BSDS-Parts
preprocess;
detect;
postprocess;




params.graph.id = 'Binary';
params.graph.vis = 0;
params.graph.recompute = 0;

params.grouping.id = 'seq';
params.grouping.vis = 0; % set this to make PDF showing overlaid detections
params.grouping.recompute = 0;

params.feature.id = 'DefDisc';
params.feature.minScore = 0.1;

params.feature.string = sprintf('%s', ...
   params.feature.id);
params.graph.string = sprintf('Graph__%s_%s', ...
   params.graph.id, params.feature.string);
params.grouping.string = sprintf('TopParts__%s_%s', ...
   params.graph.id, params.feature.string);

load('IdDataset','IdIm');  % points to images in BSDS-Parts
preprocess;
detect;
postprocess;




params.graph.id = 'Ternary';
params.graph.vis = 0;
params.graph.recompute = 0;

params.grouping.id = 'seq';
params.grouping.vis = 0; % set this to make PDF showing overlaid detections
params.grouping.recompute = 0;

params.feature.id = 'Ellipse';
params.feature.minScore = 0.1;

params.feature.string = sprintf('%s', ...
   params.feature.id);
params.graph.string = sprintf('Graph__%s_%s', ...
   params.graph.id, params.feature.string);
params.grouping.string = sprintf('TopParts__%s_%s', ...
   params.graph.id, params.feature.string);

load('IdDataset','IdIm');  % points to images in BSDS-Parts
preprocess;
detect;
postprocess;




clear global params;
global params;
params.grouping.string = 'Parts__spdg(0.30,1)';
load('IdDataset','IdIm');
postprocess;






%%
colours = lines(7);
styles = {'-' '--' ':' '-.'};
idLatexRef = 'eval-pr-4in1-BSDS';
iFig=1;
superimpose(iFig,idLatexRef,'postprocess/',{ ...
    'pr__TopParts__Ternary_DefDisc.mat' ...
    'pr__TopParts__Binary_DefDisc.mat' ...
    'pr__TopParts__Ternary_Ellipse.mat' ...
    'pr__Parts__spdg(0.30,1).mat' ...
    },{
    'ours' ...
    'ours w/o smoothing' ...
    'baseline + sequences' ...
    'baseline' ...
    }, ...
    styles([1 2 3 1]), ...
    colours([2 3 5 1],:));
axis([0 1 0 .5])
% title('BSDS-Parts','Fontsize',10);
title('','Fontsize',10);
set(iFig,'Color',[1 1 1]);
export_fig(iFig, ['postprocess/' idLatexRef '.pdf']);
