function [plotInfo] = tlSetupPlots(figureIdx, numPlots, maxSide, maxHeight, advanceFigureMethod)
%TL_SETUPPLOTS Summary of this function goes here
%   Detailed explanation goes here

    if ~exist('figureIdx', 'var')
        figureIdx = 0;
    end    
    if ~exist('numPlots', 'var')
        numPlots = -1;
    end    
    if ~exist('maxSide', 'var')
        maxSide = 0;
    end
    if ~exist('maxHeight', 'var')
        maxHeight = 0;
    end
    if ~exist('advanceFigureMethod', 'var')
        advanceFigureMethod = 'next';
    end


    if figureIdx < 1
        figureIdx = gcf;
    end
        
    if maxHeight < 1
        maxHeight = maxSide;
    end
    
    if maxSide < 1 || maxHeight < 1
        if numPlots > 0
            maxSide = ceil(sqrt(numPlots));
        else
            maxSide = 3;            
        end
        maxHeight = maxSide;
    end
    
    plotInfo.figureSize = [maxSide maxHeight];    
    
%     % if the number of plots is known and small, make figure smaller
%     if numPlots > 0
%         side = ceil(sqrt(numPlots));
%         plotInfo.figureSize = min([side side], plotInfo.figureSize);
%     end
    
    plotInfo.numPlotsPerFigure = prod(plotInfo.figureSize);    
    plotInfo.firstFigureIdx = figureIdx;
    plotInfo.curFigureIdx = figureIdx - 1;
    plotInfo.usedFigureIds = [];
    plotInfo.curPlotIdx = 0;
    
    plotInfo.nextFigureType = advanceFigureMethod;

end

